class DigicodeCodeModel {
  int? id;
  String? code;
  int? activ;
  String? label;
  int? createdAt;
  int? accessType;
  int? digicodeId;
  int? accessCounter;
  String? uniqueId;
  int? timeStart;
  int? timeStop;
  int? validDays;
  int? dateTimeStart;
  int? dateTimeStop;
  String? accessTypeLabel;
  String? placeCity;
  String? placeLabel;
  int? placeLng;
  int? placeLat;
  String? placeCountry;
  String? placeZip;
  String? placeStreet1;
  String? placeStreet2;

  DigicodeCodeModel(
      {this.id,
      this.code,
      this.activ,
      this.label,
      this.createdAt,
      this.accessType,
      this.digicodeId,
      this.accessCounter,
      this.uniqueId,
      this.timeStart,
      this.timeStop,
      this.validDays,
      this.dateTimeStart,
      this.dateTimeStop,
      this.accessTypeLabel,
      this.placeCity,
      this.placeLabel,
      this.placeLng,
      this.placeLat,
      this.placeCountry,
      this.placeZip,
      this.placeStreet1,
      this.placeStreet2});
      
  String address() =>
      ((placeStreet1 ?? '').isNotEmpty ? "$placeStreet1, " : "") +
      ((placeCity ?? '').isNotEmpty ? "$placeCity, " : "") +
      (placeCountry ?? '');

  DigicodeCodeModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["code"] is String) this.code = json["code"];
    if (json["activ"] is int) this.activ = json["activ"];
    if (json["label"] is String) this.label = json["label"];
    if (json["createdAt"] is int) this.createdAt = json["createdAt"];
    if (json["accessType"] is int) this.accessType = json["accessType"];
    if (json["digicodeId"] is int) this.digicodeId = json["digicodeId"];
    if (json["accessCounter"] is int)
      this.accessCounter = json["accessCounter"];
    if (json["uniqueId"] is String) this.uniqueId = json["uniqueId"];
    if (json["timeStart"] is int) this.timeStart = json["timeStart"];
    if (json["timeStop"] is int) this.timeStop = json["timeStop"];
    if (json["validDays"] is int) this.validDays = json["validDays"];
    if (json["dateTimeStart"] is int)
      this.dateTimeStart = json["dateTimeStart"];
    if (json["dateTimeStop"] is int) this.dateTimeStop = json["dateTimeStop"];
    if (json["accessTypeLabel"] is String)
      this.accessTypeLabel = json["accessTypeLabel"];
    if (json["placeCity"] is String) this.placeCity = json["placeCity"];
    if (json["placeLabel"] is String) this.placeLabel = json["placeLabel"];
    if (json["placeLng"] is int) this.placeLng = json["placeLng"];
    if (json["placeLat"] is int) this.placeLat = json["placeLat"];
    if (json["placeCountry"] is String)
      this.placeCountry = json["placeCountry"];
    if (json["placeZip"] is String) this.placeZip = json["placeZip"];
    if (json["placeStreet1"] is String)
      this.placeStreet1 = json["placeStreet1"];
    if (json["placeStreet2"] is String)
      this.placeStreet2 = json["placeStreet2"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["code"] = this.code;
    data["activ"] = this.activ;
    data["label"] = this.label;
    data["createdAt"] = this.createdAt;
    data["accessType"] = this.accessType;
    data["digicodeId"] = this.digicodeId;
    data["accessCounter"] = this.accessCounter;
    data["uniqueId"] = this.uniqueId;
    data["timeStart"] = this.timeStart;
    data["timeStop"] = this.timeStop;
    data["validDays"] = this.validDays;
    data["dateTimeStart"] = this.dateTimeStart;
    data["dateTimeStop"] = this.dateTimeStop;
    data["accessTypeLabel"] = this.accessTypeLabel;
    data["placeCity"] = this.placeCity;
    data["placeLabel"] = this.placeLabel;
    data["placeLng"] = this.placeLng;
    data["placeLat"] = this.placeLat;
    data["placeCountry"] = this.placeCountry;
    data["placeZip"] = this.placeZip;
    data["placeStreet1"] = this.placeStreet1;
    data["placeStreet2"] = this.placeStreet2;
    return data;
  }
}
