class EventModel {
  int? id;
  int? typeId;
  String? moreInfos;
  String? eventTitle;
  String? imageUrl;
  int? datetimeStart;
  int? realStart;
  int? datetimeStop;
  double? lng;
  double? lat;

  EventModel(
      {this.id,
      this.typeId,
      this.moreInfos,
      this.eventTitle,
      this.imageUrl,
      this.datetimeStart,
      this.realStart,
      this.datetimeStop,
      this.lng,
      this.lat});

  EventModel.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    typeId = json['typeId'];
    moreInfos = json['moreInfos'] ?? '';
    eventTitle = json['eventTitle'] ?? '';
    imageUrl = json['imageUrl'] ?? '';
    datetimeStart = json['datetimeStart'];
    realStart = json['realStart'];
    datetimeStop = json['datetimeStop'];
    lng = json['lng'] ?? 0;
    lat = json['lat'] ?? 0;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['typeId'] = this.typeId;
    data['imageUrl'] = this.imageUrl;
    data['moreInfos'] = this.moreInfos;
    data['eventTitle'] = this.eventTitle;
    data['datetimeStart'] = this.datetimeStart;
    data['realStart'] = this.realStart;
    data['datetimeStop'] = this.datetimeStop;
    data['lng'] = this.lng;
    data['lat'] = this.lat;
    return data;
  }
}
