class SeachPlaceResultModel {
  String? businessStatus;
  String? formattedAddress;
  Geometry? geometry;
  String? icon;
  String? iconBackgroundColor;
  String? iconMaskBaseUri;
  String? name;
  OpeningHours? openingHours;
  List<Photos>? photos;
  String? placeId;
  PlusCode? plusCode;
  int? priceLevel;
  double? rating;
  String? reference;
  List<String>? types;
  int? userRatingsTotal;

  SeachPlaceResultModel(
      {this.businessStatus,
      this.formattedAddress,
      this.geometry,
      this.icon,
      this.iconBackgroundColor,
      this.iconMaskBaseUri,
      this.name,
      this.openingHours,
      this.photos,
      this.placeId,
      this.plusCode,
      this.priceLevel,
      this.rating,
      this.reference,
      this.types,
      this.userRatingsTotal});

  SeachPlaceResultModel.fromJson(Map<String, dynamic> json) {
    if (json["business_status"] is String) this.businessStatus = json["business_status"];
    if (json["formatted_address"] is String) this.formattedAddress = json["formatted_address"];
    if (json["geometry"] is Map)
      this.geometry = json["geometry"] == null ? null : Geometry.fromJson(json["geometry"]);
    if (json["icon"] is String) this.icon = json["icon"];
    if (json["icon_background_color"] is String)
      this.iconBackgroundColor = json["icon_background_color"];
    if (json["icon_mask_base_uri"] is String) this.iconMaskBaseUri = json["icon_mask_base_uri"];
    if (json["name"] is String) this.name = json["name"];
    if (json["opening_hours"] is Map)
      this.openingHours =
          json["opening_hours"] == null ? null : OpeningHours.fromJson(json["opening_hours"]);
    if (json["photos"] is List)
      this.photos = json["photos"] == null
          ? null
          : (json["photos"] as List).map((e) => Photos.fromJson(e)).toList();
    if (json["place_id"] is String) this.placeId = json["place_id"];
    if (json["plus_code"] is Map)
      this.plusCode = json["plus_code"] == null ? null : PlusCode.fromJson(json["plus_code"]);
    if (json["price_level"] is int) this.priceLevel = json["price_level"];
    if (json["rating"] is double) this.rating = json["rating"];
    if (json["reference"] is String) this.reference = json["reference"];
    if (json["types"] is List)
      this.types = json["types"] == null ? null : List<String>.from(json["types"]);
    if (json["user_ratings_total"] is int) this.userRatingsTotal = json["user_ratings_total"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["business_status"] = this.businessStatus;
    data["formatted_address"] = this.formattedAddress;
    if (this.geometry != null) data["geometry"] = this.geometry?.toJson();
    data["icon"] = this.icon;
    data["icon_background_color"] = this.iconBackgroundColor;
    data["icon_mask_base_uri"] = this.iconMaskBaseUri;
    data["name"] = this.name;
    if (this.openingHours != null) data["opening_hours"] = this.openingHours?.toJson();
    if (this.photos != null) data["photos"] = this.photos?.map((e) => e.toJson()).toList();
    data["place_id"] = this.placeId;
    if (this.plusCode != null) data["plus_code"] = this.plusCode?.toJson();
    data["price_level"] = this.priceLevel;
    data["rating"] = this.rating;
    data["reference"] = this.reference;
    if (this.types != null) data["types"] = this.types;
    data["user_ratings_total"] = this.userRatingsTotal;
    return data;
  }
}

class PlusCode {
  String? compoundCode;
  String? globalCode;

  PlusCode({this.compoundCode, this.globalCode});

  PlusCode.fromJson(Map<String, dynamic> json) {
    if (json["compound_code"] is String) this.compoundCode = json["compound_code"];
    if (json["global_code"] is String) this.globalCode = json["global_code"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["compound_code"] = this.compoundCode;
    data["global_code"] = this.globalCode;
    return data;
  }
}

class Photos {
  int? height;
  List<String>? htmlAttributions;
  String? photoReference;
  int? width;

  Photos({this.height, this.htmlAttributions, this.photoReference, this.width});

  Photos.fromJson(Map<String, dynamic> json) {
    if (json["height"] is int) this.height = json["height"];
    if (json["html_attributions"] is List)
      this.htmlAttributions =
          json["html_attributions"] == null ? null : List<String>.from(json["html_attributions"]);
    if (json["photo_reference"] is String) this.photoReference = json["photo_reference"];
    if (json["width"] is int) this.width = json["width"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["height"] = this.height;
    if (this.htmlAttributions != null) data["html_attributions"] = this.htmlAttributions;
    data["photo_reference"] = this.photoReference;
    data["width"] = this.width;
    return data;
  }
}

class OpeningHours {
  bool? openNow;

  OpeningHours({this.openNow});

  OpeningHours.fromJson(Map<String, dynamic> json) {
    if (json["open_now"] is bool) this.openNow = json["open_now"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["open_now"] = this.openNow;
    return data;
  }
}

class Geometry {
  LocationResultModel? location;
  Viewport? viewport;

  Geometry({this.location, this.viewport});

  Geometry.fromJson(Map<String, dynamic> json) {
    if (json["location"] is Map)
      this.location = json["location"] == null ? null : LocationResultModel.fromJson(json["location"]);
    if (json["viewport"] is Map)
      this.viewport = json["viewport"] == null ? null : Viewport.fromJson(json["viewport"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.location != null) data["location"] = this.location?.toJson();
    if (this.viewport != null) data["viewport"] = this.viewport?.toJson();
    return data;
  }
}

class Viewport {
  Northeast? northeast;
  Southwest? southwest;

  Viewport({this.northeast, this.southwest});

  Viewport.fromJson(Map<String, dynamic> json) {
    if (json["northeast"] is Map)
      this.northeast = json["northeast"] == null ? null : Northeast.fromJson(json["northeast"]);
    if (json["southwest"] is Map)
      this.southwest = json["southwest"] == null ? null : Southwest.fromJson(json["southwest"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.northeast != null) data["northeast"] = this.northeast?.toJson();
    if (this.southwest != null) data["southwest"] = this.southwest?.toJson();
    return data;
  }
}

class Southwest {
  double? lat;
  double? lng;

  Southwest({this.lat, this.lng});

  Southwest.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    return data;
  }
}

class Northeast {
  double? lat;
  double? lng;

  Northeast({this.lat, this.lng});

  Northeast.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    return data;
  }
}

class LocationResultModel {
  double? lat;
  double? lng;

  LocationResultModel({this.lat, this.lng});

  LocationResultModel.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    return data;
  }
}
