class LanguageModel {
  late String language;
  late String code;
  late String flagCode;
  bool select = false;

  LanguageModel({
    required this.language,
    required this.code,
    required this.flagCode,
  });

  LanguageModel.fromJson(Map<String, dynamic> json) {
    language = json['language'];
    code = json['code'];
    flagCode = json['flagCode'] ?? '';
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['language'] = this.language;
    data['code'] = this.code;
    data['flagCode'] = this.flagCode;
    return data;
  }
}

class CurrencyModel {
  String? currencyName;
  String? currencyCode;
  int? subUnit;
  String? symbol;
  dynamic decimalSeparator;
  dynamic decimalPlaces;
  String? thousandSeparator;
  double? exchange;
  int? available;

  CurrencyModel(
      {this.currencyName,
      this.currencyCode,
      this.subUnit,
      this.symbol,
      this.decimalSeparator,
      this.decimalPlaces,
      this.thousandSeparator,
      this.exchange,
      this.available});

  CurrencyModel.fromJson(Map<String, dynamic> json) {
    currencyName = json["currencyName"];
    currencyCode = json["currencyCode"];
    subUnit = json["subUnit"];
    symbol = json["symbol"];
    decimalSeparator = json["decimalSeparator"];
    decimalPlaces = json["decimalPlaces"];
    thousandSeparator = json["thousandSeparator"];
    exchange = json["exchange"];
    available = json["available"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["currencyName"] = currencyName;
    _data["currencyCode"] = currencyCode;
    _data["subUnit"] = subUnit;
    _data["symbol"] = symbol;
    _data["decimalSeparator"] = decimalSeparator;
    _data["decimalPlaces"] = decimalPlaces;
    _data["thousandSeparator"] = thousandSeparator;
    _data["exchange"] = exchange;
    _data["available"] = available;
    return _data;
  }

  CurrencyModel copyWith({
    String? currencyName,
    String? currencyCode,
    int? subUnit,
    String? symbol,
    dynamic decimalSeparator,
    dynamic decimalPlaces,
    String? thousandSeparator,
    double? exchange,
    int? available,
  }) =>
      CurrencyModel(
        currencyName: currencyName ?? this.currencyName,
        currencyCode: currencyCode ?? this.currencyCode,
        subUnit: subUnit ?? this.subUnit,
        symbol: symbol ?? this.symbol,
        decimalSeparator: decimalSeparator ?? this.decimalSeparator,
        decimalPlaces: decimalPlaces ?? this.decimalPlaces,
        thousandSeparator: thousandSeparator ?? this.thousandSeparator,
        exchange: exchange ?? this.exchange,
        available: available ?? this.available,
      );
}
