/// year : "978"
/// wikipedia : [{"title":"Edward the Martyr","wikipedia":"https://wikipedia.org/wiki/Edward_the_Martyr"}]
/// description : "Edward the Martyr, English king (b. 962)"

class OnThisDayModel {
  OnThisDayModel({
    this.year,
    this.wikipedia,
    this.description,
  });

  OnThisDayModel.fromJson(dynamic json) {
    year = json['year'];
    if (json['wikipedia'] != null) {
      wikipedia = [];
      json['wikipedia'].forEach((v) {
        wikipedia?.add(Wikipedia.fromJson(v));
      });
    }
    description = json['description'];
  }

  String? year;
  List<Wikipedia>? wikipedia;
  String? description;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['year'] = year;
    if (wikipedia != null) {
      map['wikipedia'] = wikipedia?.map((v) => v.toJson()).toList();
    }
    map['description'] = description;
    return map;
  }
}

/// title : "Edward the Martyr"
/// wikipedia : "https://wikipedia.org/wiki/Edward_the_Martyr"

class Wikipedia {
  Wikipedia({
    this.title,
    this.wikipedia,
  });

  Wikipedia.fromJson(dynamic json) {
    title = json['title'];
    wikipedia = json['wikipedia'];
  }

  String? title;
  String? wikipedia;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['title'] = title;
    map['wikipedia'] = wikipedia;
    return map;
  }
}
