class PexelPhotoModel {
  int? id;
  int? width;
  int? height;
  String? url;
  String? photographer;
  String? photographerUrl;
  int? photographerId;
  String? avgColor;
  Src? src;
  bool? liked;

  PexelPhotoModel(
      {this.id,
      this.width,
      this.height,
      this.url,
      this.photographer,
      this.photographerUrl,
      this.photographerId,
      this.avgColor,
      this.src,
      this.liked});

  PexelPhotoModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["width"] is int) this.width = json["width"];
    if (json["height"] is int) this.height = json["height"];
    if (json["url"] is String) this.url = json["url"];
    if (json["photographer"] is String) this.photographer = json["photographer"];
    if (json["photographer_url"] is String) this.photographerUrl = json["photographer_url"];
    if (json["photographer_id"] is int) this.photographerId = json["photographer_id"];
    if (json["avg_color"] is String) this.avgColor = json["avg_color"];
    if (json["src"] is Map) this.src = json["src"] == null ? null : Src.fromJson(json["src"]);
    if (json["liked"] is bool) this.liked = json["liked"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["width"] = this.width;
    data["height"] = this.height;
    data["url"] = this.url;
    data["photographer"] = this.photographer;
    data["photographer_url"] = this.photographerUrl;
    data["photographer_id"] = this.photographerId;
    data["avg_color"] = this.avgColor;
    if (this.src != null) data["src"] = this.src?.toJson();
    data["liked"] = this.liked;
    return data;
  }
}

class Src {
  String? original;
  String? large2X;
  String? large;
  String? medium;
  String? small;
  String? portrait;
  String? landscape;
  String? tiny;

  Src(
      {this.original,
      this.large2X,
      this.large,
      this.medium,
      this.small,
      this.portrait,
      this.landscape,
      this.tiny});

  Src.fromJson(Map<String, dynamic> json) {
    if (json["original"] is String) this.original = json["original"];
    if (json["large2x"] is String) this.large2X = json["large2x"];
    if (json["large"] is String) this.large = json["large"];
    if (json["medium"] is String) this.medium = json["medium"];
    if (json["small"] is String) this.small = json["small"];
    if (json["portrait"] is String) this.portrait = json["portrait"];
    if (json["landscape"] is String) this.landscape = json["landscape"];
    if (json["tiny"] is String) this.tiny = json["tiny"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["original"] = this.original;
    data["large2x"] = this.large2X;
    data["large"] = this.large;
    data["medium"] = this.medium;
    data["small"] = this.small;
    data["portrait"] = this.portrait;
    data["landscape"] = this.landscape;
    data["tiny"] = this.tiny;
    return data;
  }
}
