import '../resources.dart';

class HomeRepo {
  HomeRepo._();

  static HomeRepo? _instance;

  factory HomeRepo([AppApi? api]) {
    if (_instance == null) _instance = HomeRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<List<HomePlaceModel>> getHomesAroundMe(lat, lng,
      {distance = 100000, languageCode}) async {
    NetworkResponse response = await _api.getHomesAroundMe({
      'lat': lat,
      'lng': lng,
      'distance': distance,
      'languageCode': languageCode
    });
    return response.data ?? [];
  }

  Future<List<BrPromotedVideoModel>> getPromotedVideosForOoh({lat, lng}) async {
    NetworkResponse response = await _api.getPromotedVideosForOoh(lat, lng);
    return response.data ?? [];
  }

  Future<List<HomePurposeType>> getHomePurposeTypesList(params) async {
    NetworkResponse response = await _api.getHomePurposeTypesList(params);
    return response.data ?? [];
  }

  Future<List<HomeCountryAvaliable>> getCountriesavailableForHomes(
      params) async {
    NetworkResponse response = await _api.getCountriesavailableForHomes(params);
    return response.data ?? [];
  }

  Future<List<HomeCategory>> getHomeCatList(params) async {
    NetworkResponse response = await _api.getHomeCatList(params);
    return response.data ?? [];
  }

  Future<HomeDetailInfo?> getHomeDetailsById(params) async {
    NetworkResponse response = await _api.getHomeDetailsById(params);
    return response.data;
  }

  Future<List<HomeAttribute>> getHomeAttributesList(params) async {
    NetworkResponse response = await _api.getHomeAttributesList(params);
    return response.data ?? [];
  }

  Future<List<HomeCity>> getCitiesListByPurposeId(params) async {
    NetworkResponse response = await _api.getCitiesListByPurposeId(params);
    return response.data ?? [];
  }

  Future<List<HomeCity>> getHomeCitiesList(params) async {
    NetworkResponse response = await _api.getHomeCitiesList(params);
    return response.data ?? [];
  }

  Future<List<HomeDetailInfo>> getHomesListByFilters(params) async {
    NetworkResponse response = await _api.getHomesListByFilters(params);
    return response.data ?? [];
  }

  Future<bool> setHomeBookmark(params) async {
    NetworkResponse response = await _api.setHomeBookmark(params);
    return response.data ?? false;
  }

  Future<bool> setMainPicForHome(bytes, path, homeId) async {
    NetworkResponse response =
        await _api.setMainPicForHome(bytes, path, homeId);
    return response.data ?? false;
  }

  Future<int> getNumberOfHomesForCurrentFilters(params) async {
    NetworkResponse response =
        await _api.getNumberOfHomesForCurrentFilters(params);
    return response.data ?? 0;
  }

  Future<HomeDetailInfo?> createOohHome(params) async {
    NetworkResponse response = await _api.createOohHome(params);
    return response.data;
  }
}
