import '../resources.dart';

class ProductRepo {
  ProductRepo._();

  static ProductRepo? _instance;

  factory ProductRepo([AppApi? api]) {
    _instance ??= ProductRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<List<ProductCategory>> getProductCategories() async {
    NetworkResponse response = await _api.getProductCategories();
    return response.data ?? [];
  }

  Future<List<ProductCategory>> v2GetProductCategories() async {
    NetworkResponse response = await _api.v2GetProductCategories({"": ""});
    return response.data ?? [];
  }

  Future<List<ProductCategory>> v2getProductRefByCatId(params) async {
    NetworkResponse response = await _api.v2getProductRefByCatId(params);
    return response.data ?? [];
  }

  Future<List<ProductStatus>> getStatusList() async {
    NetworkResponse response = await _api.getStatusList();
    return response.data ?? [];
  }

  Future<List<ProductModel>> getProductsFromPro(params) async {
    NetworkResponse response = await _api.getProductsFromPro(params);
    return response.data ?? [];
  }

  Future<List<ProductModel>> getProductOfProFromSA(params) async {
    NetworkResponse response = await _api.getProductOfProFromSA(params);
    return response.data ?? [];
  }

  Future<List<ProductModel>> getProductOfUserFromSA(params) async {
    NetworkResponse response = await _api.getProductOfUserFromSA(params);
    return response.data ?? [];
  }

  Future<bool> updateTerminalFromPro({terminalId, label, direction}) async {
    Map params = {"terminalId": terminalId};
    if (direction != null) params.addAll({'direction': direction});
    if (label != null) params.addAll({'label': label});
    NetworkResponse response = await _api.updateTerminalFromPro(params);
    return response.data ?? false;
  }

  Future<bool> updateProduct(
      {productId, productStatusId, placeId, label}) async {
    Map params = {"productId": productId};
    if (label != null) params.addAll({'label': label});
    if (placeId != null) params.addAll({'placeId': placeId});
    if (productStatusId != null) {
      params.addAll({'productStatusId': productStatusId});
    }
    NetworkResponse response = await _api.updateProduct(params);
    return response.data ?? false;
  }
}
