import 'package:_private_core/_private_core.dart';
import '../resources.dart';

class QRRepository {
  QRRepository._();

  static QRRepository? _instance;

  factory QRRepository([AppApi? api]) {
    _instance ??= QRRepository._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<ScanQr?> scanDeviceQr(qrCode) async {
    NetworkResponse response = await _api.scanDeviceQr(
        {'qrCode': qrCode, 'languageCode': appPrefs.languageCode});
    return response.data;
  }

  Future<QrDataModel?> getAnythingFromQr(code) async {
    NetworkResponse response = await _api
        .getAnythingFromQr({'qr': code, 'languageCode': appPrefs.languageCode});
    return response.data;
  }
}
